
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.Windows.Forms.Grid

Public Class Form1
    Inherits System.Windows.Forms.Form
    Private groupBox1 As System.Windows.Forms.GroupBox
    Private components As System.ComponentModel.Container = Nothing
    Private dir As ListSortDirection


    Public Sub New()
        InitializeComponent()
    End Sub 'New


    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose

#Region "Windows Form Designer generated code"
    Friend WithEvents GridControl1 As Syncfusion.Windows.Forms.Grid.GridControl


    Private Sub InitializeComponent()
        Me.groupBox1 = New System.Windows.Forms.GroupBox
        Me.GridControl1 = New Syncfusion.Windows.Forms.Grid.GridControl
        Me.groupBox1.SuspendLayout()
        CType(Me.GridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'groupBox1
        '
        Me.groupBox1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.groupBox1.Controls.Add(Me.GridControl1)
        Me.groupBox1.Font = New System.Drawing.Font("Sylfaen", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.groupBox1.Location = New System.Drawing.Point(32, 24)
        Me.groupBox1.Name = "groupBox1"
        Me.groupBox1.Size = New System.Drawing.Size(632, 392)
        Me.groupBox1.TabIndex = 0
        Me.groupBox1.TabStop = False
        Me.groupBox1.Text = "GridControl"
        '
        'GridControl1
        '
        Me.GridControl1.ColCount = 6
        Me.GridControl1.DefaultColWidth = 70
        Me.GridControl1.DefaultRowHeight = 20
        Me.GridControl1.Location = New System.Drawing.Point(104, 128)
        Me.GridControl1.Name = "GridControl1"
        Me.GridControl1.Size = New System.Drawing.Size(472, 240)
        Me.GridControl1.SmartSizeBox = False
        Me.GridControl1.TabIndex = 0
        Me.GridControl1.Text = "GridControl1"
        Me.GridControl1.ThemesEnabled = True
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(688, 446)
        Me.Controls.Add(Me.groupBox1)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.groupBox1.ResumeLayout(False)
        CType(Me.GridControl1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub 'InitializeComponent 
#End Region


    <STAThread()> _
    Shared Sub Main()
        Application.Run(New Form1)
    End Sub 'Main


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        PopulateGrid()
        AddHandler Me.GridControl1.CellClick, AddressOf gridControl1_CellClick
    End Sub 'Form1_Load


    Sub PopulateGrid()
        Dim i As Integer
        For i = 1 To 3
            Dim j As Integer
            For j = 1 To 2
                Me.gridControl1(i, j).CellValue = String.Format("{0}{1}", i, j)
            Next j
        Next i
    End Sub 'PopulateGrid

    Private Sub gridControl1_CellClick(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCellClickEventArgs)
        If e.ColIndex > 0 AndAlso e.RowIndex = 0 Then
            If dir = ListSortDirection.Descending Then
                dir = ListSortDirection.Ascending
            Else
                dir = ListSortDirection.Descending
            End If
            Me.gridControl1.Data.SortByColumn(e.ColIndex, dir, New NewComparer)
            Me.gridControl1.Refresh()
        End If
    End Sub 'gridControl1_CellClick
End Class 'Form1

#Region " NewComparer  "
Public Class NewComparer
    Implements IComparer 'ToDo: Add Implements Clauses for implementation methods of these interface(s)
#Region "Implementation of IComparer"

    Public Function [Compare](ByVal x As Object, ByVal y As Object) As Integer Implements IComparer.Compare
        If x Is Nothing AndAlso y Is Nothing Then
            Return 0
        End If
        If x Is Nothing Then
            Return 0
        ElseIf y Is Nothing Then
            Return 0
        Else
            Dim xStyle As New GridStyleInfo(CType(x, GridStyleInfoStore))
            Dim yStyle As New GridStyleInfo(CType(y, GridStyleInfoStore))
            Dim xs As String = xStyle.Text
            Dim ys As String = yStyle.Text
            Dim xd As Double = 0
            Dim yd As Double = 0
            Double.TryParse(xStyle.Text, System.Globalization.NumberStyles.Any, Nothing, xd)
            Double.TryParse(yStyle.Text, System.Globalization.NumberStyles.Any, Nothing, yd)
            Return xd.CompareTo(yd)
        End If '				return ((IComparable) x.ToString()).CompareTo(y.ToString());
    End Function 'Compare
#End Region
End Class 'NewComparer
#End Region